--
--    No Role Check Spam - Allows undress and target model for dressing room
--    Copyright (C) 2013  Rachael Alexanderson
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <http://www.gnu.org/licenses/>.
--

local SysMessage = NRCS_SysMessage;

local function englishOnOff(conditional)
	if (conditional) then return "|cff00ff00enabled|r"; else return "|cffff0000disabled|r"; end
end

if not ( NRCS_Version == NRCS_CoreVersion ) then
	return;
end

if NRCS_Global == nil then NRCS_Global = {} end;

-- Code based on LUA-only options panel code found on wowpedia.org
-- Credit goes to CurtWulf and Mortilus
NRCS = {};
NRCS.config = {}; NRCS.change = {}; NRCS.text = {};
NRCS.config.s1 = "Enable";
NRCS.config.s2 = "Messages";
NRCS.config.s3 = "AutoSpec";
NRCS.change.s1 = "Addon ";
NRCS.change.s2 = "Show Messages ";
NRCS.change.s3 = "Automatic Role Select ";
NRCS.text.s1 = "Enable This Addon";
NRCS.text.s2 = "Show Addon Messages";
NRCS.text.s3 = "Auto Role Select for Current Spec";

if NRCS_Global[NRCS.config.s1] == nil then NRCS_Global[NRCS.config.s1] = false; end
if NRCS_Global[NRCS.config.s2] == nil then NRCS_Global[NRCS.config.s2] = false; end
if NRCS_Global[NRCS.config.s3] == nil then NRCS_Global[NRCS.config.s3] = false; end

NRCS.panel = CreateFrame( "Frame", "NRCSPanel", UIParent );

-- Register in the Interface Addon Options GUI
-- Set the name for the Category for the Options Panel
NRCS.panel.name = "No Role Check Spam";
-- Add the panel to the Interface Options
InterfaceOptions_AddCategory(NRCS.panel);

NRCS.panel.text1 = NRCS.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall");
NRCS.panel.text1:SetPoint("TOP",0,-100);
NRCS.panel.text1:SetText("No Role Check Spam "..NRCS_Version.." by Allikitten (Allicilea of US-MoonGuard)");

NRCS.panel.option1 = CreateFrame("CheckButton", "NRCSOption1", NRCS.panel, "UICheckButtonTemplate");
NRCS.panel.option1:SetPoint("CENTER",-90,45);
NRCS.panel.option1.text = _G["NRCSOption1Text"];
NRCS.panel.option1.text:SetText(NRCS.text.s1);
NRCS.panel.option1:SetScript("OnClick",function(self,event,arg1)
	NRCS_Global[NRCS.config.s1] = self:GetChecked()
	SysMessage(NRCS.change.s1..englishOnOff(NRCS_Global[NRCS.config.s1])..".");
end);

NRCS.panel.option2 = CreateFrame("CheckButton", "NRCSOption2", NRCS.panel, "UICheckButtonTemplate");
NRCS.panel.option2:SetPoint("CENTER",-90,15);
NRCS.panel.option2.text = _G["NRCSOption2Text"];
NRCS.panel.option2.text:SetText(NRCS.text.s2);
NRCS.panel.option2:SetScript("OnClick",function(self,event,arg1)
	NRCS_Global[NRCS.config.s2] = self:GetChecked()
	SysMessage(NRCS.change.s2..englishOnOff(NRCS_Global[NRCS.config.s2])..".");
end);

NRCS.panel.option3 = CreateFrame("CheckButton", "NRCSOption3", NRCS.panel, "UICheckButtonTemplate");
NRCS.panel.option3:SetPoint("CENTER",-90,-15);
NRCS.panel.option3.text = _G["NRCSOption3Text"];
NRCS.panel.option3.text:SetText(NRCS.text.s3);
NRCS.panel.option3:SetScript("OnClick",function(self,event,arg1)
	NRCS_Global[NRCS.config.s3] = self:GetChecked()
	SysMessage(NRCS.change.s3..englishOnOff(NRCS_Global[NRCS.config.s3])..".");
end);

local function SetOptionsPanel()
	if ( NRCS_Global[NRCS.config.s1] ) then
			NRCS.panel.option1:SetChecked(true); else
			NRCS.panel.option1:SetChecked(false); end
	NRCS_Option1 = NRCS_Global[NRCS.config.s1];
	if ( NRCS_Global[NRCS.config.s2] ) then
			NRCS.panel.option2:SetChecked(true); else
			NRCS.panel.option2:SetChecked(false); end
	NRCS_Option2 = NRCS_Global[NRCS.config.s2];
	if ( NRCS_Global[NRCS.config.s3] ) then
			NRCS.panel.option3:SetChecked(true); else
			NRCS.panel.option3:SetChecked(false); end
	NRCS_Option3 = NRCS_Global[NRCS.config.s3];
end

local function NRCS_Cancel()
	local didchange = false;
	if ( NRCS_Global[NRCS.config.s1] ~= NRCS_Option1 ) then didchange = true; end
	if ( NRCS_Global[NRCS.config.s2] ~= NRCS_Option2 ) then didchange = true; end
	if ( NRCS_Global[NRCS.config.s3] ~= NRCS_Option3 ) then didchange = true; end
	NRCS_Global[NRCS.config.s1] = NRCS_Option1;
	NRCS_Global[NRCS.config.s2] = NRCS_Option2;
	NRCS_Global[NRCS.config.s3] = NRCS_Option3;
	if didchange then
		SysMessage("Canceled Options Change");
	end
end

NRCS.panel.cancel = function (self) NRCS_Cancel();  end;
NRCS.panel.refresh = function (self) SetOptionsPanel();  end;

local function parseSwitch(textconditional,originalstate)
	if textconditional == "on" then return true;
	elseif textconditional == "true" then return true;
	elseif textconditional == "1" then return true;
	elseif textconditional == "off" then return false;
	elseif textconditional == "false" then return false;
	elseif textconditional == "0" then return false;
	elseif originalstate == false then return true;
	else return false;
	end
end

SLASH_NRCS1, SLASH_NRCS2 = '/NRCS', '/NoRoleCheckSpam';
function SlashCmdList.NRCS(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");

	command = string.lower(command);

	if command == "help" then
		SysMessage("/NRCS help - Shows this help");
		SysMessage("/NRCS "..NRCS.config.s1.." [on/off] - "..NRCS.text.s1);
		SysMessage("/NRCS "..NRCS.config.s2.." [on/off] - "..NRCS.text.s2);
		SysMessage("/NRCS "..NRCS.config.s3.." [on/off] - "..NRCS.text.s3);
	elseif command == string.lower(NRCS.config.s1) then
		NRCS_Global[NRCS.config.s1] = parseSwitch(rest,NRCS_Global[NRCS.config.s1]);
		SysMessage(NRCS.change.s1..englishOnOff(NRCS_Global[NRCS.config.s1])..".");
		SetOptionsPanel();
	elseif command == string.lower(NRCS.config.s2) then
		NRCS_Global[NRCS.config.s2] = parseSwitch(rest,NRCS_Global[NRCS.config.s2]);
		SysMessage(NRCS.change.s2..englishOnOff(NRCS_Global[NRCS.config.s2])..".");
		SetOptionsPanel();
	elseif command == string.lower(NRCS.config.s3) then
		NRCS_Global[NRCS.config.s3] = parseSwitch(rest,NRCS_Global[NRCS.config.s3]);
		SysMessage(NRCS.change.s3..englishOnOff(NRCS_Global[NRCS.config.s3])..".");
		SetOptionsPanel();
	elseif command == "" then
		InterfaceOptionsFrame_OpenToCategory(NRCS.panel);
		SysMessage("Opening Options Frame.");
	else
		SysMessage("Unrecognized command. Type /NRCS help for a list of options.");
	end
end
